/*
 * Screen2TileGenerator.java
 *
 * Created on 6 de junio de 2006, 22:45
 */

package algarrobo.msx;

import java.awt.Color;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import javax.imageio.ImageIO;

/**
 *
 * @author avelino
 */
public class Screen2TileGenerator {
    
    public static void main(String[] args) {
        try {
            FileInputStream is = new FileInputStream(args[0]);
            FileOutputStream os = new FileOutputStream(args[1]);
            PrintStream ps = new PrintStream(os);
            //PrintStream ps = System.out;
            BufferedImage image = ImageIO.read(is);
            int width = image.getWidth();
            int height = image.getHeight();
            int horizTiles = width / 8;
            int vertTiles = height / 8;
            for (int v = 0; v < vertTiles; v++) {
                for (int h = 0; h < horizTiles; h++) {
                    int xOffset = h * 8;
                    int yOffset = v * 8;
                    Rectangle rect = new Rectangle(xOffset, yOffset, 8, 8);
                    BufferedImage tile = image.getSubimage(xOffset, yOffset, 8, 8);
                    // output tile info
                    ps.print("\tdb ");
                    for (int yTile = 0; yTile < 8; yTile++) {
                        int value = 0;
                        for (int xTile = 0; xTile < 8; xTile++) {
                            Color color = new Color(tile.getRGB(xTile, yTile));
                            if (color.getGreen() == 255) {
                                // white
                            }
                            else {
                                // black
                                value |= 1 << (7 - xTile);
                            }
                        }
                        ps.print(value);
                        if (yTile < 7)
                            ps.print(", ");
                        else
                            ps.println();
                    }
                }
            }
            ps.close();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
}
